# -*- coding: utf-8 -*-

from IRCLibs import irclib
from IRCLibs import ircbot

# Banque de regex pour le bot
from Tests.Regex_LG import Regex_LG as rlg

from multiprocessing import Process

from config import *

# Classe permettant d'ajouter des bots de test
class Dummy(ircbot.SingleServerIRCBot):

    role = ""
    name = ""

    # Passer le nom du bot en paramètre
    def __init__(self, name):
        self.name = name
        ircbot.SingleServerIRCBot.__init__(
                self, [(IRC_SERVER, IRC_PORT)], name, "Bot de test LG", 5)

    # Action lors du lancement
    def on_welcome(self, serv, ev):
        serv.join(MAIN_CHANNEL)

    # Action lors d'une invitation, seule l'invitation sur WOLF_CHANNEL est validée
    def on_invite(self, serv, ev):
        if ev.arguments()[0] == WOLF_CHANNEL:
            serv.join(WOLF_CHANNEL)
            serv.privmsg(BOT_OWNER, "J'ai rejoint le camp des loups")

    # Messages privés
    def on_privmsg(self, serv, ev): 

        # Récupération de l'émetteur et du message
        sender = ev.source().split("!")[0]
        message = ev.arguments()[0]

        # Cas envoi par propriétaire
        if BOT_OWNER in sender:

            # Mets fin au bot
            if "!die" in message:
                serv.privmsg(MAIN_CHANNEL, "C'est un bot qui sort d'un canal...")
                self.die()

            # Message à envoyer sur le canal principal
            if "!say" in message:  
                serv.privmsg(MAIN_CHANNEL, " ".join(message.split(" ")[1:]))

            if "!whisper" in message:
                serv.privmsg(BOT_NAME, " ".join(message.split(" ")[1:]))

        # Cas envoi par autre personne
        elif BOT_NAME in sender:

            # Récupération du rôle (1er message au bot de test)
            if self.role == "":
                self.role = rlg.getRole().match(message).group(1) 
                print self.name + " : " + self.role
            serv.privmsg(BOT_OWNER, "< " + sender + "> " + message)

    # Messages publics
    def on_pubmsg(self, serv, ev):

        # Récupération de l'émetteur, du canal et du message
        sender = ev.source().split("!")[0]
        message = ev.arguments()[0]
        canal = ev.target()

        # Cas envoi par propriétaire
        if BOT_OWNER in sender and (WOLF_CHANNEL in canal or MAIN_CHANNEL in canal):

            # Tout le monde MEURT
            if "!die" in message:
                serv.privmsg(MAIN_CHANNEL, "AAAAAH")
                self.die()

            # Tout le monde rejoint la partie
            if "!newgame" in message:
                serv.privmsg(MAIN_CHANNEL, "!join")

            # Tout le monde vote pour un malheureux dans le bon canal
            if "!vote" in message:
                serv.privmsg(canal, message)

# Fin classe Dummy

if __name__ == '__main__':
    p1 = Process(target=Dummy("Tinky_Winky").start)
    p2 = Process(target=Dummy("Dipsy").start)
    p3 = Process(target=Dummy("Laa-Laa").start)
    p4 = Process(target=Dummy("Po").start)
    p5 = Process(target=Dummy("Tiic").start)
    p6 = Process(target=Dummy("Taac").start)
    p1.start()
    p2.start()
    p3.start()
    p4.start()
    p5.start()
    p6.start()
